uniform sampler2D rendertexture1, rendertexture2;
uniform int renderpass;
uniform float ddx, ddy, brightness;

void main(void)
{
	vec4 outPix = vec4(0.0, 0.0, 0.0, 0.0);
	vec2 uv = gl_TexCoord[0].st;
	float kernel[4];
	kernel[0] = 0.015625;
	kernel[1] = 0.09375;
	kernel[2] = 0.234375;
	kernel[3] = 0.3125;
	if(renderpass == 1)
	{
		outPix += kernel[0] * texture2D(rendertexture1, uv + vec2(-ddx * 3.0, 0.0));
		outPix += kernel[1] * texture2D(rendertexture1, uv + vec2(-ddx * 2.0, 0.0));
		outPix += kernel[2] * texture2D(rendertexture1, uv + vec2(-ddx * 1.0, 0.0));
		outPix += kernel[3] * texture2D(rendertexture1, uv + vec2(0.0, 0.0));
		outPix += kernel[2] * texture2D(rendertexture1, uv + vec2(ddx * 1.0, 0.0));
		outPix += kernel[1] * texture2D(rendertexture1, uv + vec2(ddx * 2.0, 0.0));
		outPix += kernel[0] * texture2D(rendertexture1, uv + vec2(ddx * 3.0, 0.0));
	}
	if(renderpass == 2)
	{
		outPix += kernel[0] * texture2D(rendertexture1, uv + vec2(0.0, -ddy * 3.0));
		outPix += kernel[1] * texture2D(rendertexture1, uv + vec2(0.0, -ddy * 2.0));
		outPix += kernel[2] * texture2D(rendertexture1, uv + vec2(0.0, -ddy * 1.0));
		outPix += kernel[3] * texture2D(rendertexture1, uv + vec2(0.0, 0.0));
		outPix += kernel[2] * texture2D(rendertexture1, uv + vec2(0.0, ddy * 1.0));
		outPix += kernel[1] * texture2D(rendertexture1, uv + vec2(0.0, ddy * 2.0));
		outPix += kernel[0] * texture2D(rendertexture1, uv + vec2(0.0, ddy * 3.0));
	}
	//if((outPix.x + outPix.y + outPix.z)/3 > 0.1)
		gl_FragColor = outPix * brightness;
}
