uniform sampler2D Texture0;
uniform sampler2D Texture1;
uniform samplerCube CubeMap;
uniform float MixRatio;
uniform int pass;

varying vec3 viewVec, lightVec, Normal;
varying float dist;
void main()
{
	if(pass == 0)
	{
		vec4 base = texture2D(Texture0, gl_TexCoord[0].st);
		vec4 ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient * base;
		gl_FragColor = ambient;
	}
	if(pass == 2)
	{
		vec3 n = normalize(texture2D(Texture1, gl_TexCoord[0].st).rgb * 2.0 - 1.0) * normalize(Normal);
		vec3 l = lightVec * inversesqrt(dist * dist);
		//vec3 n = normalize(Normal);
		//vec3 l = normalize(lightVec);
		vec3 r = reflect(normalize(viewVec), n);
		r.x = -r.x;
		vec4 base;
		vec4 envColor;
		vec4 diffuse, specular;
		float NdotL = max(dot(n,l),0.0);
		
		if(NdotL >= 0.0)
		{
			base = texture2D(Texture0, gl_TexCoord[0].st);
			envColor = textureCube(CubeMap,r);
			diffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * NdotL;
		}

		vec4 finalColor = mix(envColor, base, MixRatio);
		
		gl_FragColor = diffuse * finalColor;
	}
	//gl_FragColor = /*texture2D(Texture0, gl_TexCoord[0].st);*/textureCube(CubeMap, ReflectDir);
}
