varying vec3 lightVec, viewVec, normal;
varying float dist;
uniform sampler2D Texture0, Texture1, Texture2;
uniform int pass;

void lighting(vec3 l, vec3 n, vec3 v, float dist)
{
	float NdotL = max(dot(n, l), 0.0);
	float att;
	vec4 ambient, diffuse, specular, base, gloss;
	ambient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
	if(NdotL >= 0.0)
	{
		base = texture2D(Texture0, gl_TexCoord[0].st);
		gloss = texture2D(Texture2, gl_TexCoord[0].st);
		att = 1.0 / (gl_LightSource[0].constantAttenuation +
				gl_LightSource[0].linearAttenuation * dist +
				gl_LightSource[0].quadraticAttenuation * dist * dist);
		diffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * NdotL; 
		
		specular = gl_LightSource[0].specular * gl_FrontMaterial.specular * pow(clamp(dot(reflect(-l, n), v),0.0, 1.0),gl_FrontMaterial.shininess);
	}
	gl_FragColor = (ambient * base + diffuse * base + specular * gloss) * att;
}
void amblight()
{
	vec4 ambient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
	vec4 base = texture2D(Texture0, gl_TexCoord[0].st);
	gl_FragColor = ambient * base;
}
void main()
{
	if(pass == 2)
	{
		//vec3 l = lightVec * inversesqrt(dist * dist);
		vec3 l = normalize(lightVec);
		vec3 n = normalize(texture2D(Texture1, gl_TexCoord[0].st).rgb * 2.0 - 1.0) * normalize(normal);
		//vec3 n = normalize(normal);
		vec3 v = normalize(viewVec);
		lighting(l, n, v, dist);
	}
	else if(pass == 0)
	{
		amblight();
	}
}
